unit uGUI;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, Buttons, StdCtrls, DBGrids, DBCtrls, HSButton, kbmMemTable,
  kbmMemBinaryStreamFormat, kbmMemCSVStreamFormat, kbmMemSQL;

type

  { TGUI }

  TGUI = class(TForm)
    BtnHelpOnOff: TButton;
    BtnCreateNewField: TButton;
    BtnIdx: TButton;
    ClrBtnAddNewField: THSButton;
    ClrBtnCloseApp: THSButton;
    ClrBtnTest: THSButton;
    ClrBtnSave: THSButton;
    ClrBtnClear: THSButton;
    ClrBtnAddFieldDefinition: THSButton;
    ClrBtnExportBDS2: THSButton;
    ClrBtnExport_Save: THSButton;
    ClrBtnHelpClose: THSButton;
    ClrBtnSaveDatset2: THSButton;
    ClrBtnFirst: THSButton;
    ClrBtnNext: THSButton;
    ClrBtnPrior: THSButton;
    ClrBtnLast: THSButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    Edit1: TEdit;
    Edit2: TEdit;
    EdtAddField: TEdit;
    EdtAddSize: TEdit;
    ClrBtnReset: THSButton;
    ClrBtnImportLoad: THSButton;
    kbmBinaryStreamFormat1: TkbmBinaryStreamFormat;
    kbmBinaryStreamFormat2: TkbmBinaryStreamFormat;
    kbmCSVStreamFormat1: TkbmCSVStreamFormat;
    kbmCSVStreamFormat2: TkbmCSVStreamFormat;
    kbmMemSQL1: TkbmMemSQL;
    kbmMemSQL2: TkbmMemSQL;
    kbmMemTable1: TkbmMemTable;
    kbmMemTable2: TkbmMemTable;
    Memo1: TMemo;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    SaveDialog1: TSaveDialog;
    SaveDialog2: TSaveDialog;
    procedure BtnCreateNewFieldClick(Sender: TObject);
    procedure BtnHelpOnOffClick(Sender: TObject);
    procedure BtnIdxClick(Sender: TObject);
    procedure ButtonLoadClick(Sender: TObject);
    procedure ClrBtnAddNewFieldClick(Sender: TObject);
    procedure ClrBtnClearClick(Sender: TObject);
    procedure ClrBtnAddFieldDefinitionClick(Sender: TObject);
    procedure ClrBtnCloseAppClick(Sender: TObject);
    procedure ClrBtnExportBDS2Click(Sender: TObject);
    procedure ClrBtnExport_SaveClick(Sender: TObject);
    procedure ClrBtnFirstClick(Sender: TObject);
    procedure ClrBtnLastClick(Sender: TObject);
    procedure ClrBtnNextClick(Sender: TObject);
    procedure ClrBtnPriorClick(Sender: TObject);
    procedure ClrBtnSaveClick(Sender: TObject);
    procedure ClrBtnHelpCloseClick(Sender: TObject);
    procedure ClrBtnSaveDatset2Click(Sender: TObject);
    procedure ClrBtnTestClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ClrBtnImportLoadClick(Sender: TObject);
    procedure ClrBtnResetClick(Sender: TObject);
  private

  public

  end;

var
  GUI: TGUI;

    AddFieldName, NwFieldName             : string;
    AddFieldKind, NwFieldKind             : TFieldType;
    AddFieldSize, NwFieldSize             : Integer;
    ColumnLast                            : Integer;
    ColumTitleString, MemTable_Dataset_Filename : String;

////////////////////////////////////////////////////////////////////////////////

implementation

{$R *.lfm}

////////////////////////////////////////////////////////////////////////////////

{ TGUI }

procedure TGUI.BtnCreateNewFieldClick(Sender: TObject);
begin
  kbmMemTable1.Close;
  // Dependant on choice 1 new datset
  CLrBtnImportLoad.Enabled:= False;
  GUI.ShowHint := False;
  // Check if Edit1 contains text
  if Edit1.Text <= '' then
    begin
      Showmessage('You must enter a name for the field');
      BtnCreateNewField.Enabled:=False;
    end
  else
    begin
      BtnCreateNewField.Enabled := True;
      // Check if Combobox contaisn a field type
      if ComboBox1.Text <= ''
      then Showmessage('Please select a field kind')
      else
      // Check if EdtAddField contains teh field size
      If Edit1.Text <= '' then Showmessage('Please select a field size');
      // The boolean set at the end is already set to true
      // It is required by the syntax
    end;

  NwFieldName := Edit1.Text;
  NwFieldKind := TFieldType(ComboBox1.ItemIndex);
  NwFieldSize := StrToInt(EdtAddField.Text);

  kbmMemTable1.FieldDefs.Add (NwFieldName, NwFieldKind, NwFieldSize, True);
  // kbmMemTable1.FieldDefs.Add ('NAAM',   ftString,    20,          True);


  kbmMemTable1.CreateTable;
end;

procedure TGUI.BtnHelpOnOffClick(Sender: TObject);
begin
  Panel4.Visible := Not Panel4.Visible ;
end;


procedure TGUI.BtnIdxClick(Sender: TObject);
Var I : Integer;
Begin
   I := 1;
   kbmMemTable2.First;
   While Not kbmMemTable2.Eof Do
   Begin
      kbmMemTable2.Edit;
     // The simple way
      kbmMemTable2.FieldByName ('ID').AsInteger := I;

      kbmMemTable2.Post;
      kbmMemTable2.Next;
      Inc (I);
   End;
End;

procedure TGUI.ButtonLoadClick(Sender: TObject);
begin
 // kbmMemTable1.Clear;
  kbmMemTable1.EmptyTable;
end;

procedure TGUI.ClrBtnAddNewFieldClick(Sender: TObject);
begin
  kbmMemTable2.Close;
  kbmMemTable2.Fields.Clear;
  AddFieldName :=  EdtAddField.Text;                  // reeds the fieldname
  AddFieldKind :=  TFieldType(ComboBox2.ItemIndex);   // reeds the fieldkind by the index number of the combobox
  AddFieldSize :=  StrToInt(EdtAddSize.Text);         // reeds the fieldsize

  // The simple way:
  // BufDataSet.FieldDefs.Add ('ID',   ftInteger, 0, False);

  kbmMemTable2.FieldDefs.Add (AddFieldName, AddFieldKind, AddFieldSize, False);
 // kbmMemTable2.CreateDataSet;
   kbmMemTable2.active:= true;
end;

procedure TGUI.ClrBtnClearClick(Sender: TObject);
begin
  kbmMemTable1.ClearFields;
end;

procedure TGUI.ClrBtnAddFieldDefinitionClick(Sender: TObject);
begin

  kbmMemTable2.FieldDefs.Assign (kbmMemTable1.FieldDefs);
 // kbmMemTable2.CreateDataSet;
 // kbmMemTable2.CreateTable;
  kbmMemTable2.Active:= true;
end;

procedure TGUI.ClrBtnCloseAppClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TGUI.ClrBtnExportBDS2Click(Sender: TObject);
var I : Integer ;
begin
  DBGrid1.Visible := False;
  DBGrid2.Visible := False;
  kbmMemTable1.First;

  While Not kbmMemTable1.Eof Do
  Begin
    kbmMemTable2.Insert;
    For I := 0 To kbmMemTable1.FieldCount - 1 Do kbmMemTable2.Fields [I].Assign (kbmMemTable1.Fields [I]);
    kbmMemTable2.Post;
    kbmMemTable1.Next
  End;

 DBGrid1.Visible := True;
 DBGrid2.Visible := True;
end;

procedure TGUI.ClrBtnExport_SaveClick(Sender: TObject);
begin
  if SaveDialog2.Execute then  ShowMessage('File : ' + SaveDialog2.FileName);
  kbmMemTable2.SaveToFile(SaveDialog2.FileName);
end;
////////////////////////////////////////////////////////////////////////////////
procedure TGUI.ClrBtnFirstClick(Sender: TObject);
begin
  With kbmMemTable2 do
  if active then
    begin
  //    showmessage('active');
      First
    end
  else
    begin
   //   showmessage(' not active');
      exit;
    end
end;

procedure TGUI.ClrBtnNextClick(Sender: TObject);
begin
    With kbmMemTable2 do
  if active then
    begin
   //   showmessage('active');
      Next
    end
    else
      begin
   //   showmessage(' not active');
      exit;
    end
end;

procedure TGUI.ClrBtnPriorClick(Sender: TObject);
begin
  With kbmMemTable2 do
  if active then
    begin
   //   showmessage('active');
      Prior
    end
    else
      begin
   //   showmessage(' not active');
      exit;
    end
end;

procedure TGUI.ClrBtnLastClick(Sender: TObject);
begin
  With kbmMemTable2 do
  if active then
    begin
   //   showmessage('active');
      Last
    end
    else
      begin
  //    showmessage(' not active');
      exit;
    end
end;
////////////////////////////////////////////////////////////////////////////////
procedure TGUI.ClrBtnSaveClick(Sender: TObject);
begin
  if SaveDialog1.Execute then ShowMessage('File : ' + SaveDialog1.FileName);
  kbmMemTable1.SaveToFile(SaveDialog1.FileName);
end;

procedure TGUI.ClrBtnHelpCloseClick(Sender: TObject);
begin
  Panel4.Visible := False;
end;

procedure TGUI.ClrBtnSaveDatset2Click(Sender: TObject);
begin
  With kbmMemTable2 do
    begin
      Post;

      SaveToFile(MemTable_Dataset_Filename);  // global Var = extracted from OpenDialog1
    end;
end;

procedure TGUI.ClrBtnTestClick(Sender: TObject);
begin
  DBGrid2.SelectedIndex := (0);
  ColumnLast := dbgrid2.Columns.Count;
  DBGrid2.SelectedIndex := (ColumnLast -1);
  kbmMemTable2.Edit;
end;


procedure TGUI.FormCreate(Sender: TObject);
Var Compiledate : String; aDate : TDateTime;
begin
  // Compiledate:=DateTimeToStr(FileDateToDateTime(FileAge(ExtractFileName(Application.ExeName))));
  // Deprecated  so this is the best way to do it: use function Exedate

  if FileAge(Application.ExeName,adate) then
    CompileDate:=DateTimeToStr(aDate)
  else CompileDate:='?';

  Caption := 'COMPILE DATE:' + ' ' +Compiledate +'     '
        + '  Path ' + ExtractFilePath(Application.ExeName) ; // Path

end;

procedure TGUI.ClrBtnImportLoadClick(Sender: TObject);
begin
  DBGrid1.Visible := True;
  DBGrid2.Visible := True;
  if OpenDialog1.Execute then // ShowMessage('File : ' + openDialog1.FileName);
  kbmMemTable1.LoadFromFile(openDialog1.FileName);//
  MemTable_Dataset_Filename := OpenDialog1.FileName;
end;

procedure TGUI.ClrBtnResetClick(Sender: TObject);
begin
  kbmMemTable1.Close;
  kbmMemTable2.Close;
  kbmMemTable1.Fields.clear;
  kbmMemTable2.Fields.clear;
end;



end.

